
%% Load matrix
A = [2, 1, 1, 0; 4, 3, 3, 1; 8, 7, 9, 5; 6, 7, 9, 8];
% A(1,1) = 1e-6; % Uncomment this line to obtain the second matrix A_2

%% Own LU decomposition without pivotization
[L, U] = myLU(A);
fprintf('myLU error: %e\n', norm(A - L*U));

%% MATLAB's LU decomposition with pivotization
[LP, UP, P] = lu(A);
% Alternatively [LP, UP] = lu(A) is fine as well

%% Method comparison for fixed right hand side
b = sum(A, 2);

x = U \ (L \ b);
fprintf('Residual without pivotization: %e\n', norm(b - A*x));

xP = UP \ (LP \ (P * b)); % or UP \ (LP \ b) without P
fprintf('Residual with pivotization: %e\n', norm(b - A*xP));