
function [L,U] = myLU(A)
% Compute the LU decomposition of a square matrix A by Gaussian elimination
% without pivotization.

    n = size(A,1);
    L = eye(n);
    U = A;
    for i = 1:n-1
        for j = i+1:n
            L(j,i) = U(j,i)/U(i,i);
            U(j,i:end) = U(j,i:end) - L(j,i)*U(i,i:end);
        end
    end
end