function yEval = polynomialLeastSquares(x, y, degree, xEval)

    % Transform all vectors to column format
    x = x(:);
    y = y(:);
    xEval = xEval(:);

    % Setup system matrix
    A = x.^(0:degree);

    % Solve normal equation
    coeffs = (A'*A) \ (A'*y);
    
    % Evaluate polynomial
    yEval = (xEval .^ (0:degree)) * coeffs;
end

